# -*- coding:sjis
#ꑊΘ_IQ[
#L[ňړBZL[Ȃ炾ƍړB
#Xy[XL[ŃX^[gB
#Eɕ\Ă̂͏ԁBꂪ100𒴂ĂAĂB100菬͂ȂȂB
#VL^oƁAIɃvCf[^܂B
#

import sys
import pygame
from pygame.locals import *
import math
from math import cos,sin,pi
import random
from random import randint,random as rand
import time
"""
pygame.draw.line(screen,color,start_point,end_point,width=1)
pygame.draw.lines(screen,color,closed,pointlist,width=1)
    closed=true or false
pygame.display.flip()
x,y=pygame.mouse.get_pos()
rect=pygame.Rect(x,y,w,h)
pygame.draw.rect(screen,color,Rect,width=0)

"""

Enemy_color=(255,0,0)
Enemy_dsize_x=10.0
Enemy_dsize_y=10.0
Plane_color=(0,0,255)
Plane_dsize_x=10.0
Plane_dsize_y=10.0
Field_size_x=5.0
Field_size_y=5.0

SCR_W=SCR_H=720
Back_ground_color=(0,0,0)
Score_file_name="score"
Replay_file_name="replay"

def draw_rect(screen,color,pos,size):
    w=size[0]
    h=size[1]
    x=pos[0]-w/2
    y=pos[1]-h/2
    pygame.draw.rect(screen,color,pygame.Rect(SCR_W*(1+x)/2,SCR_H*(1+y)/2,SCR_W*w,SCR_H*h))

def draw_lines(screen,color,pointlist):
    plist=[(ad_size(SCR_W*(1+x)/2),ad_size(SCR_H*(1+y)/2)) for x,y in pointlist]
    #print plist
    pygame.draw.lines(screen,color,True,plist)

def draw_line(screen,color,edge):
    p1,p2=[(ad_size(SCR_W*(1+x)/2),ad_size(SCR_H*(1+y)/2)) for x,y in edge]
    pygame.draw.line(screen,color,p1,p2)

def draw_polygon(screen,color,pointlist):
    plist=[(SCR_W*(1+x)/2,SCR_H*(1+y)/2) for x,y in pointlist]
    pygame.draw.polygon(screen,color,plist)


def mm3(matrix,vec):
    a00,a01,a02,a10,a11,a12,a20,a21,a22=matrix
    t,x,y=vec
    _t=a00*t+a01*x+a02*y
    _x=a10*t+a11*x+a12*y
    _y=a20*t+a21*x+a22*y
    return (_t,_x,_y)

def ad_size(n):
    return max(-2**30,min(2**30,n))

def make_color(s):
    s=int(s*255)%(255*3)
    t=s%255
    if 0<=s<255:
        return (255-t,t,0)
    elif 255<=s<255*2:
        return (0,255-t,t)
    elif 255*2<=s:
        return (t,0,255-t)

def rot_check(pos1,pos2):
    x1,y1=pos1
    x2,y2=pos2
    return x1*y2>=x2*y1

class Move_point:
    def __init__(self,pos,velo,has_timer,t=0):
        self.pos=pos
        self.velo=velo
        self.t=t
        self.has_timer=has_timer
    def matrix(self,m):
        x,y=self.pos
        vx,vy=self.velo
        a0,a1,a2=mm3(m,(1.0,vx,vy))
        b0,b1,b2=mm3(m,(0.0,x,y))
        
        _vx=a1/a0
        _vy=a2/a0

        _x=b1-a1*b0/a0
        _y=b2-a2*b0/a0

        self.pos=(_x,_y)
        self.velo=(_vx,_vy)
        self.t=a0*self.t+b0
    def next_state(self):
        x,y=self.pos
        vx,vy=self.velo
        self.pos=(x+vx*0.01,y+vy*0.01)
        if self.has_timer:
            self.t+=math.sqrt(1-vx*vx-vy*vy)*0.01

class Enemy:
    def __init__(self,kind,data=None):
        self.kind=kind
        if kind==1:
            pos,velo,size=data
            x,y=pos
            w,h=size
            p1=Move_point((x-w/2,y-h/2),velo,False)
            p2=Move_point((x-w/2,y+h/2),velo,False)
            p3=Move_point((x+w/2,y+h/2),velo,False)
            p4=Move_point((x+w/2,y-h/2),velo,False)
            p5=Move_point((x    ,    y),velo,True)
            
            self.point_list=[p1,p2,p3,p4,p5]
            self.edge_list=[(p1,p2),(p2,p3),(p3,p4),(p4,p1)]
            self.polygon_list=[(p1,p2,p3,p4)]
            self.live=True
            self.danger=True
            self.mortal=True
        elif kind==2:
            pos,velo,size=data
            x,y=pos
            w,h=size
            p1=Move_point((x    ,y-h/2),velo,False)
            p2=Move_point((x-w/2,y    ),velo,False)
            p3=Move_point((x    ,y+h/2),velo,False)
            p4=Move_point((x+w/2,y    ),velo,False)
            p5=Move_point((x    ,    y),velo,False)
            
            self.point_list=[p1,p2,p3,p4,p5]
            self.edge_list=[(p1,p2),(p2,p3),(p3,p4),(p4,p1)]
            self.polygon_list=[(p1,p2,p3,p4)]
            self.live=True
            self.danger=True
            self.mortal=True
        elif kind==3:
            w,h=data
            velo=(0.0,0.0)
            p1=Move_point((-w/2,-h/2),velo,False)
            p2=Move_point((-w/2,+h/2),velo,False)
            p3=Move_point((+w/2,+h/2),velo,False)
            p4=Move_point((+w/2,-h/2),velo,False)
            
            self.point_list=[p1,p2,p3,p4]
            self.edge_list=[(p1,p2),(p2,p3),(p3,p4),(p4,p1)]
            self.polygon_list=[]
            self.live=True
            self.danger=True
            self.mortal=False
        elif kind==4:
            n=data
            fsx=Field_size_x/2
            fsy=Field_size_y/2
            dx=fsx/n
            dy=fsx/n
            pl_1=[Move_point((i*dx,-fsy),(0.0,0.0),False) for i in xrange(-n+1,n)]
            pl_2=[Move_point((i*dx,+fsy),(0.0,0.0),False) for i in xrange(-n+1,n)]
            pl_3=[Move_point((-fsx,i*dy),(0.0,0.0),False) for i in xrange(-n+1,n)]
            pl_4=[Move_point((+fsx,i*dy),(0.0,0.0),False) for i in xrange(-n+1,n)]
            
            self.point_list=pl_1+pl_2+pl_3+pl_4
            self.edge_list=[(u,d)for u,d in zip(pl_1,pl_2)+zip(pl_3,pl_4)]
            self.polygon_list=[]
            self.live=True
            self.danger=False
            self.mortal=False
        else:
            raise"wrong kind"
    def next_state(self):
        for mp in self.point_list:
            mp.next_state()
    def color(self):
        if self.kind==1:
            return make_color(self.point_list[4].t)
        elif self.kind==2:
            return (255,255,255)
        elif self.kind==3:
            return (255,255,255)
        elif self.kind==4:
            return (30,0,0)
    def display(self,screen):
        color=self.color()
        for p1,p2 in self.edge_list:
            draw_line(screen,color,(p1.pos,p2.pos))
        for polygon in self.polygon_list:
            draw_polygon(screen,color,[mp.pos for mp in polygon])
            
    def matrix(self,m):
        for mp in self.point_list:
            mp.matrix(m)
    def crash(self):
        if not self.danger:
            return False
        for mp1,mp2 in self.edge_list:
            p1=mp1.pos
            p2=(mp1.pos[0]+mp1.velo[0]*0.01,mp1.pos[1]+mp1.velo[1]*0.01)
            p3=(mp2.pos[0]+mp2.velo[0]*0.01,mp2.pos[1]+mp2.velo[1]*0.01)
            p4=mp2.pos

            t1=rot_check(p1,p2)
            t2=rot_check(p2,p3)
            t3=rot_check(p3,p4)
            t4=rot_check(p4,p1)
            if( t1 and t2 and t3 and t4)or not (t1 or t2 or t3 or t4 ):
                return True
        else:
            False
    def out(self):
        p5=self.point_list[4]
        if p5.t<10.0 and -2<=p5.pos[0]<=2 and -2<=p5.pos[1]<=2:
            return False
        else:
            return True
        
class Enemys:
    def __init__(self):
        self.enemy=[Enemy(kind=3,data=(Field_size_x,Field_size_y)),
                    Enemy(kind=4,data=10),
                    ]
        self.time=0
        self.step=0
    def reset(self):
        self.__init__()        
    def next_state(self):
        self.time+=1
        k=max(30-self.time/1000,1)
        #if self.time%200==0:
        #    new_enemy=Enemy((0.0,0.0),(0.0,0.0),(0.5,0.5),kind=4)
        #    self.enemy.append(new_enemy)
        if self.time%k==0:
            self.step+=1
            r=randint(0,3)
            rv=rand()
            rp=rand()*2-1
            rs=0.05+rand()*0.15
            if self.step%10==0:
                ra=rand()*2*pi
                rx=cos(ra)
                ry=sin(ra)
                data=(rx*2,ry*2),(-rx,-ry),(0.10,0.10)
                new_enemy=Enemy(kind=2,data=data)
            else:
                if r==0:
                    data=(rp,-1.5),(0,rv),(rs,rs)
                elif r==1:
                    data=(rp, 1.5),(0,-rv),(rs,rs)
                elif r==2:
                    data=(-1.5,rp),(rv,0),(rs,rs)
                elif r==3:
                    data=(1.5,rp),(-rv,0),(rs,rs)
                new_enemy=Enemy(kind=1,data=data)
            self.enemy.append(new_enemy)
        for e in self.enemy:
            if e.live:
                if e.crash():
                    self.game.state=2
                    self.game.flag_crash=True
                e.next_state()
        self.live_check()
    def live_check(self):
        deletelist=[]
        for enemy in self.enemy:
            if enemy.mortal and enemy.live and enemy.out():
                enemy.live=False
    def matrix(self,m):
        for e in self.enemy:
            if e.live:
                e.matrix(m)

    def display(self,screen):
        for e in self.enemy:
            if e.live:
                e.display(screen)

class Plane:
    def __init__(self,pos=(SCR_W/2,SCR_H/2)):
        self.pos=pos
    def next_state(self):
        if self.game.replay_mode:
            key=self.game.replay_key_code.next()
        else:
            key=self.game.key_code.generate()
            self.game.key_log.append(key)
        if key[4]==1:
            vx=vy=0.04
            den=math.sqrt(1-0.04**2)
        else:
            vx=vy=0.01
            den=math.sqrt(1-0.01**2)
        if key[0]==1:
            m=[1/den  ,0,vy/den,
               0      ,1,0     ,
               vy/den ,0,1/den ,]
        elif key[1]==1:
            m=[1/den  ,0,-vy/den,
               0      ,1,0      ,
               -vy/den,0,1/den  ,]
        elif key[2]==1:
            m=[1/den  ,-vx/den,0,
               -vx/den,1/den  ,0,
               0      ,0      ,1,]
        elif key[3]==1:
            m=[1/den  ,vx/den,0,
               vx/den,1/den  ,0,
               0      ,0      ,1,]
        else:
            m=[1,0,0,
               0,1,0,
               0,0,1]

        self.game.enemys.matrix(m)
            
    def display(self,screen):
        x=self.pos[0]-Enemy_dsize_x/2
        y=self.pos[1]-Enemy_dsize_y/2
        w=Plane_dsize_x
        h=Plane_dsize_y
        pygame.draw.rect(screen,Plane_color,pygame.Rect(x,y,w,h))

class Back_ground:
    def __init__(self):
        pass
    def next_state(self):
        pass
    def display(self,screen):
        pygame.draw.rect(screen,Back_ground_color,pygame.Rect(0,0,SCR_W,SCR_H))

class Game:
    def __init__(self):
        self.key_code=Key_code()
        self.key_code.game=self
        self.flag_crash=False
        self.replay_mode=False
    def reset(self):
        self.back_ground=Back_ground()
        self.enemys=Enemys()
        self.plane=Plane()
        self.syorioti=Syorioti()
        self.state=1
        self.draw_objs= [self.back_ground,self.plane,
                         self.enemys,self.score,self.syorioti]
        self.objs=      [self.back_ground,self.plane,
                         self.enemys,self.score,self.syorioti]
        for obj in self.objs:
            obj.game=self
        self.score.score=0
        if self.replay_mode:
            random.seed(self.seed)
            self.replay_key_code=(i for i in self.saved_key_log)
        else:
            self.key_log=[]
            self.seed=time.time()
            random.seed(self.seed)

    def title(self):
        self.back_ground=Back_ground()
        self.logo=Logo()
        self.choice=Choice()
        self.draw_objs=self.objs=[self.back_ground,self.logo,self.choice]
        self.state=1
        for obj in self.objs:
            obj.game=self
    def flag_check(self):
        if self.flag_crash:
            self.flag_crash=False
            if self.score.score==self.score.high_score and not self.replay_mode:
                save_data(self)
                self.draw_objs.append(MESSAGE_HIGH_SCORE())

class Logo:
    def __init__(self):
        font=pygame.font.Font(None,150)
        self.text=font.render("SRTyoke",False,(255,255,255))
    def next_state(self):
        pass    
    def display(self,screen):
        screen.blit(self.text,(100,100))
class Choice:
    def __init__(self):
        self.font=pygame.font.Font(None,64)
        self.choice=0
    def next_state(self):
        key=self.game.key_code.generate()
        if key[0]:
            self.choice=0
        elif key[1]:
            self.choice=1
        if key[5]:
            if self.choice==0:
                self.game.reset()
            elif self.choice==1:
                self.game.seed,self.game.saved_key_log=load_replay()
                self.game.replay_mode=True
                self.game.reset()
            else:
                raise""
    def display(self,screen):
        white=(255,255,255)
        gray=(40,40,40)
        c1,c2=[(white,gray),(gray,white)][self.choice]
        text1=self.font.render("START",False,c1)
        text2=self.font.render("REPLAY",False,c2)
        screen.blit(text1,(300,300))
        screen.blit(text2,(300,360))
        

class Score:
    def __init__(self,high_score=0):
        self.score=0
        self.high_score=high_score
        self.font=pygame.font.Font(None,32)
    def reset(self):
        self.score=0
    def next_state(self):
        self.score+=1
        self.high_score=max(self.high_score,self.score)
    def display(self,screen):
        text=self.font.render("%s   :   %s"%(self.score,self.high_score),
                              False,
                              (255,255,255))
        screen.blit(text,(0,0))

class Syorioti:
    def __init__(self):
        self.step=25
        self.list=[0.01 for i in xrange(self.step)]
        self.i=0
        self.font=pygame.font.Font(None,32)
    def next_state(self):
        self.list[self.i]=self.game.loss
        self.i=(self.i+1)%self.step
    def display(self,screen):
        n=int(sum(self.list)*4*100)
        text=self.font.render("%s"%n,False,(100,100,100))
        screen.blit(text,(SCR_W-75,0))

class Key_code:
    def __init__(self):
        pass
    def next_state(self):
        pass
    def display(self,screen):
        pass
    def generate(self):
        key=self.game.key
        # up down right left z space
        return key[273],key[274],key[275],key[276],key[122],key[32]
class MESSAGE_HIGH_SCORE():
    def __init__(self):
        font=pygame.font.Font(None,96)
        self.text=font.render("NEW RECORD!",False,(255,255,255))
    def next_state(self):
        pass
    def display(self,screen):
        screen.blit(self.text,(200,200))

def all_obj():
    return [Back_ground(),Enemys(),Plane()]

def load_score():
    f=open(Score_file_name,"rb")
    n=int(f.read())
    f.close()
    return n

def load_replay():
    f=open(Replay_file_name,"rb")
    s=f.read()
    f.close()
    return eval(s)

def save_data(game):
    f=open(Score_file_name,"wb")
    f.write(str(game.score.score))
    f.close()

    replay_data=repr([game.seed,game.key_log])

    f=open(Replay_file_name,"wb")
    f.write(replay_data)
    f.close()

def main():
    
    pygame.init()
    screen=pygame.display.set_mode((SCR_W,SCR_H))

    game=Game()
    game.score=Score(high_score=load_score())
    game.title()

    pygame.display.flip()
    wait_timer=time.time()
    while 1:
        for event in pygame.event.get():
            if event.type==QUIT:
                return
        _wait_timer=time.time()
        if _wait_timer>=wait_timer+0.01:
            pass
            #print"syorioti!!"
        else:
            while _wait_timer<wait_timer+0.01:
                _wait_timer=time.time()
        game.loss=_wait_timer-wait_timer
        wait_timer=_wait_timer
        
        game.key=pygame.key.get_pressed()
        for obj in game.draw_objs:
            if game.state==1:
                obj.next_state()
            obj.display(screen)
        if game.state==2 and game.key_code.generate()[5]==1:
            game.reset()
        game.flag_check()
        pygame.display.flip()
main()
